package locacao;

import java.util.Scanner;

/**
 *
 * @author Alunos
 */
public class FicharioLocacao {
    private Locacao[] locacoes;
    private Midia midias[];
    private Cliente clientes[];
    private Scanner ler;

    public FicharioLocacao(Cliente vetCli[], Midia vetMid[], Locacao vetLoc[]) {
        locacoes = vetLoc;
        midias = vetMid;
        clientes = vetCli;
        
        ler = new Scanner(System.in);
    }

    public void cadastrar() {
        float preco;
        String dataEnt, dataLoc;
        int cont = 0, posCli, posMid;
        
        while (locacoes[cont] != null) { //verifica se tem espaço desocupado no vetor
            cont++;
        }

        if (cont < 50) {
            System.out.println(" == Cadastrar Locação == ");
            do{
                System.out.println("Qual a posição do cliente no vetor? ");
                posCli = ler.nextInt();
                ler.skip("\n");
            }while(clientes[posCli] == null);

            do{
                System.out.println("Qual a posição da mídia no vetor? ");
                posMid = ler.nextInt();
                ler.skip("\n");
            }while(midias[posMid] == null);

            System.out.println(" Digite o preço da locação: ");
            preco = ler.nextFloat();
            ler.skip("\n");
            System.out.println(" Digite a data da locação: ");
            dataLoc = ler.nextLine();
            System.out.println(" Digite a data de devolução: ");
            dataEnt = ler.nextLine();

            Locacao loc; //objeto para cada posição
            loc = new Locacao(preco, 0, dataLoc, dataEnt, midias[posMid],
                clientes[posCli]);

            locacoes[cont] = loc;
        } else {
            System.out.println(" Vetor cheio. Não suporta mais cadastros. ");
        }
    }

    public void alterar() {
        String dataent, dataloc;
        float preco, multa;
        int pos;

        System.out.println(" ====Alterar LOCAÇÃO==== ");
        System.out.println("Qual a posição do vetor deseja alterar? ");
        pos = ler.nextInt();
        ler.skip("\n");

        if (locacoes[pos] != null) {
            System.out.println("Cliente: ");
            locacoes[pos].getCliente().getNome();

            System.out.println("Mídia: ");
            locacoes[pos].getMidia().getTitulo();

            System.out.println(" Data de locação atual: " + locacoes[pos].getDataLocacao()); //get_ pega valor do objeto
            System.out.println("Digite a nova data de locação: ");
            dataloc = ler.nextLine();
            locacoes[pos].setDataLocacao(dataloc); // set_ coloca o valor no objeto

            System.out.println(" Data de devolução atual: " + locacoes[pos].getDataDevolucao()); //get_ pega valor do objeto
            System.out.println("Digite a nova data de devolução: ");
            dataent = ler.nextLine();
            locacoes[pos].setDataDevolucao(dataent); // set_ coloca o valor no objeto

            System.out.println(" Preco atual: " + locacoes[pos].getPreco()); //get_ pega valor do objeto
            System.out.println("Digite o novo preço: ");
            preco = ler.nextFloat();
            locacoes[pos].setPreco(preco); // set_ coloca o valor no objeto

            System.out.println(" Multa atual: " + locacoes[pos].getMulta()); //get_ pega valor do objeto
            System.out.println("Digite a nova multa: ");
            multa = ler.nextFloat();
            locacoes[pos].setMulta(multa); // set_ coloca o valor no objeto
            
            System.out.println("Atualização realizada com sucesso.");
        } else {
            System.out.println(" Posicao inválida. ");
        }
    }

    public void excluir() {
        int pos, resp;

        System.out.println(" --==[Excluir Locação]==-- ");
        System.out.println("Qual a posição do vetor deseja excluir? ");
        pos = ler.nextInt();
        ler.skip("\n"); 

        if (locacoes[pos] != null) {
            imprimir(locacoes[pos]); 
            System.out.println("Confirma a exclusão? (1-sim) e (2-não) ");
            resp = ler.nextInt();
            ler.skip("\n"); 

            if (resp == 1) {
                locacoes[pos] = null; // exclui um objeto do vetor
                System.out.println(" Exclusão efetuada com sucesso. ");

            } else {
                System.out.println(" Exclusão não efetuada. ");
            }
        } else {
            System.out.println(" Posição inválida. ");
        }
    }

    public void consultar() {
        int pos;

        System.out.println(" --==[Consultar Locação]==-- ");
        System.out.println("Qual a posição do vetor deseja consultar? ");
        pos = ler.nextInt();
        ler.skip("\n"); 

        // testa se existe um carro na posição escolhida pelo usuário
        if (locacoes[pos] != null) {
            imprimir(locacoes[pos]);
        } else {
            System.out.println(" Posição inválida. ");
        }
    }

    public void relatorio() {
        System.out.println(" --==[Relatório de Locação]==-- ");
        for (int j = 0; j < locacoes.length; j++) {
            if (locacoes[j] != null) {
                imprimir(locacoes[j]);
                System.out.println("---------------------");
            }
        }
    }

    public void imprimir(Locacao l){
        System.out.println("== Cliente =================");
        System.out.println(" Nome         : " + l.getCliente().getNome());
        System.out.println(" Endereco     : " + l.getCliente().getEnd());
        System.out.println(" Telefone     : " + l.getCliente().getFone());
        System.out.println(" CPF          : " + l.getCliente().getCpf());
        System.out.println("== Mídia ===================");
        System.out.println(" Nome     : " + l.getMidia().getTitulo());
        System.out.println(" Sinopse  : " + l.getMidia().getSinopse());
        System.out.println(" Categoria: " + l.getMidia().getCategoria());
        System.out.println(" Tipo     : " + l.getMidia().getTipo());
        System.out.println("== Locação =================");
        System.out.println(" Preço da locação: " + l.getPreco());
        System.out.println(" Multa           : " + l.getMulta());
        System.out.println(" Data da locação : " + l.getDataLocacao());
        System.out.println(" Data de entrega : " + l.getDataDevolucao());
        System.out.println("");
    }
}
